/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "param.h"
#include "gen.h"
#include "gddconfig.h"
#include "parse.h"
#include "error.h"
#include "sniffloop.h"
#include "gdd_printf.h"

/*============================================================================
 Program entry
  ============================================================================
*/
int main(int argc,char *argv[])
{
    static GDDCONFIG        gddc;
    pid_t                   pid;

    if (parse_commandline(&gddc,argc,argv)<0)
        return(0);
    init_gddprintf(gddc.param_mode==PARAMMODE_CFGFILE);
    start_logging(gddc.errlog);
    if (gddc.startup_message)
        errorlog(ERRLOG_NOTIFY,"gdd started\n");

    if (gddc.mode==MODE_NORMAL){
        if ((pid=fork())==-1){
            errorlog(ERRLOG_FATAL,"fork() error\n");
            return(0);
        }
        if (pid==0){
            sniffloop(&gddc);
            end_logging();
        }else
            end_logging();
    }else
        sniffloop(&gddc);

    return(0);
}
