/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    Thanks: SIN <sin@sapporoworks.ne.jp>
            http://homepage2.nifty.com/spw/
    He told me usage of RAW socket on Win32 !

 *****************************************************************************/

#include <stdio.h>
#include "depend.h"
#include "param.h"
#include "promisc.h"
#include "analyze.h"
#include "gddconfig.h"
#include "error.h"
#include "resource.h"

/*============================================================================
 Main loop (read packet and analyze it)
 [INPUT]
  gddc      : Configuration data of gdd
 [RETURN]
  none
  ============================================================================
*/
void sniffloop(GDDCONFIG *gddc)
{
    int                 CreateWindowForConsoleApp(GDDCONFIG *gddc);
    HWND                GethWndConsole(void);
    HWND                hWnd;

    gddc->egui.hInstance = GetModuleHandle(0);
    hWnd=GethWndConsole();
    
    /* Hide console window */
    if (gddc->param_mode==PARAMMODE_CFGFILE){
        /* Create dialogbox */
        ShowWindow(hWnd,0);
        
        DialogBoxParam(gddc->egui.hInstance, MAKEINTRESOURCE(IDD_MAIN),
		               NULL, WndProc,(LPARAM)gddc);
    }else{  
        CreateWindowForConsoleApp(gddc);
    }
}

/*============================================================================
 Get window handle of this console application
 [INPUT]
  none
 [RETURN]
  none
  ============================================================================
*/
HWND GethWndConsole(void)
{ 
    HWND                hWnd;
    char                buf0[256],buf1[256];

    GetConsoleTitle(buf0,sizeof(buf0));
    srand(GetTickCount());
    sprintf(buf1,"%d",rand());
    SetConsoleTitle(buf1);
    Sleep(100);
    hWnd=FindWindow(NULL,buf1);
    SetConsoleTitle(buf0);
    return(hWnd);
} 

/*============================================================================
 Create window for console application
 [INPUT]
  gddc      : Configuration data of gdd
 [RETURN]
  none
  ============================================================================
*/
int CreateWindowForConsoleApp(GDDCONFIG *gddc)
{
    LRESULT CALLBACK    WndProc_dummywindow(HWND hWnd,UINT msg,WPARAM wparam,LPARAM lparam);
    WNDCLASS            wc;
    HWND                hWnd;
    MSG                 msg;

    memset(&wc,0,sizeof(wc));
    wc.lpszClassName = CLASSNAME;
    wc.style         = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc   = (WNDPROC)WndProc_dummywindow;
    wc.hInstance     = gddc->egui.hInstance;
    wc.hIcon         = LoadIcon(gddc->egui.hInstance,MAKEINTRESOURCE(IDI_ICON));
    wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW);

    if(!RegisterClass(&wc)
     ||!(hWnd=CreateWindow(CLASSNAME,CLASSNAME,WS_OVERLAPPEDWINDOW,
            CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
            NULL,NULL,gddc->egui.hInstance,(void *)gddc))){
        return (-1);
    }
    while(GetMessage(&msg,NULL,0,0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    return(0);
}
